########### COMPUTING BOOTSTRAP TEST STATISTICS T_{n,7} for Example 9.6
######################################################################## 

###### The AAR(2) model is fitted by using the code: aar2.s, which is
###### slight modifications of the aar2.s in chapter 8 so that it
###### use two bandwidths f = 0.2 (automatic selected) and f = 0.35
###### the results are saved as fig95.res and fig95.res1, respectively.
###### In the GLR test, setting iband = 1 ====> using f=0.2,
###### the results are stored at `GLR.res'
######                                = 0 ====> using f=0.35
###### the results are stored at `GLR.res1'
###### USAGE:  source("Ex97test.s") to get the results

iband <- 0








################  Computing RSS_0 for AR(2) model ###############
lynx <- scan("../datasets/lynx.dat")
x  <- log10(lynx)
n <- length(x); p <- 2
#x  <- x - mean(x)
ar.res <- ar(x, order.max=2)
resid <- ar.res$resid
resid <- resid[-c(1,2)]
fitted <- x[3:length(lynx)] - resid
RSS0 <- sum(resid^2)
print(c("RSS0 = ", RSS0))

###############  AAR(2) fitting and RSS_1   ############
### after running aar2.s, results were stored in fig95.res or fig95.res1

if(iband==1) resid <- fig95.res[,3]
if(iband==0) resid <- fig95.res1[,3]

RSS1 <- sum(resid^2)
print(c("RSS1 = ", RSS1))
GLR0 <- (length(x)-p)*log(RSS0/RSS1)/2
print(c("GLR = ", GLR0))
res <- c(RSS0, RSS1, GLR0)

################  Creating regression structure  #######

#Y <- x[(p+1):n]
X1 <- x[p:(n-1)]
X2 <- x[(p-1):(n-2)]


##############  Conditional estimation of null distribution ######
 f  <- 0.2                                     # smoothing parameter
 B  <- 1000                                    # number of boostrap replications
 GLR <- rep(0, B)                              #GLR statistic
 .Random.seed <- c(21,35,40,21,40, 0,20,32,37,39,31, 0)
		#save the .Random.seed so that result is repeatable


 for(i in 1:B)
 {
	print(i)
 	Y  <-   fitted + sample(resid,replace=T)      #bootstrap sample
 	RSS0 <- lsfit(cbind(X1,X2),Y)$resid           #null model fit
 	RSS0 <- sum(RSS0^2)                    

 	######### alternative model   #########
 	series  <- data.frame(y= Y,x1=X1,x2=X2)
 	res.gam <- gam(y ~ lo(x1,f) + lo(x2,f),data=series)
 	resid     <- res.gam$resid
 	RSS1      <- sum(resid^2)
 	GLR[i] <- (n-p)*log(RSS0/RSS1)/2
 }

print(paste("RSS0 = ", res[1]))  
print(paste("RSS1 = ", res[2]))  
print(paste("GLR statistic = ", res[3]))  
print(paste("p-value = ", mean(GLR > GLR0)))  

if(iband == 1) 
  {GLR.res <- GLR
   print("Bootstrap GLR statistic is saved at 'GLR.res'")
  }
if(iband==0)    
  {GLR.res1 <- GLR
   print("Bootstrap GLR statistic is saved at 'GLR.res1'")
   }

rm(res, ar.res, n, p, x, fitted, resid, RSS1, GLR0, f, B, Y, X1, X2, GLR, RSS0) 
